<p align="center">
    <img src="https://user-images.githubusercontent.com/52280338/222252617-f86be28d-f2f3-4871-a0bf-00e7c42080fa.png" alt="mu-node-authentication" />
</p>
<h1 align="center">Sparql Editor</h1>
<h2 align="center">Sparql Editor based on CodeMirror 6</h2>

<p align="center">
  <img src="https://img.shields.io/github/package-json/v/aatauil/sparql-editor" />
  <a href="LICENSE">
    <img src="https://img.shields.io/badge/license-MIT-yellow.svg" alt="license: MIT" />
  </a>
  <a href="https://github.com/aatauil/sparql-editor/actions/workflows/publish.yml">
    <img src="https://github.com/aatauil/sparql-editor/actions/workflows/publish.yml/badge.svg" alt="npm publish" />
  </a>
  </a>
</p>

---

## Functionality:

- 🏳‍🌈 Syntax highlighting
- 📔 History 
- 💢 Linting
- 🔎 Search
- ℹ️ tooltip 

# :open_book: Documentation
## Usage recommendation
Editor is stable. Currently it is being used by the [sparql-browser-extension](https://github.com/aatauil/sparql-browser-extension). It returns a Codemirror 6 EditorView instance. So you can manipulate the editor as documented in the [codemirror documentation](https://codemirror.net/docs/ref/)  


## Description
Codemirror 6 editor instance with some sane presets and some additional functionality. It uses [codemirror-lang-sparql](https://github.com/aatauil/codemirror-lang-sparql) parser for syntax highlighting. Linting and linting errors are being generated by the [SPARQL.js](https://github.com/RubenVerborgh/SPARQL.js) package. 

## Getting Started

`npm i sparql-editor`

```js
  import { createSparqlEditor } from "sparql-editor"
  
  const domElement = document.getElementById("editor")

  const editor = createSparqlEditor({
    parent: domElement,
    onChange: onChange,
    value: "SELECT * WHERE { ?s ?p ?o }"
  });

  function onChange(value, codemirrorViewInstance) {
      console.log(codemirrorViewInstance)
      alert(value)
  }
```

## Options
| ENV  | Description | default | required |
|---|---|---|---|
| parent | html dom element to attach editor to | / | required
| onChange | function that gets called whenever editor value changes  | / |   |
| value |  Initial value of editor | https://github.com/aatauil/sparql-editor/blob/4732494949e44910d8ca45d0391331b520ae9ee0/src/index.ts#L32-L37  |  |

## Extending the editor
Currently there is no easy way for adding extentions to the editor, this will hopefully be added soon. Until then, the best direction to take is forking this project, installing or deleting extensions and updating the index.ts file accordingly.  

## Development guide

- clone this repo
- `cd` into it
- run `npm install`
- run `npm run dev` 

In the test folder there is a index.html file. Your editor probably has an extension that can easily serve this file for you. In case you are using VSCode, you can use the Live Server Extension. 

## 📍 Roadmap 
[x] Tooltip functionality <br />
[] Linting by codemirror-lang-sparql <br />
[] Autocomplete functionality <br />
[] Extensible extensions <br />

# :orange_heart: Contributing

Everyone can open an issue or send in a pull request. 


# 📝 License

This project is [MIT](LICENSE) licensed.
